#ifndef KPPTY_H
#define KPPTY_H

#include <qmultilineedit.h>
#include <qstringlist.h>
#include <qregexp.h> 

#include <kprocio.h>

//////////////////////////////////////////////////////////////////////////////

class kpKProcIO: public KProcIO
{
   Q_OBJECT

public:
   
   kpKProcIO ( QTextCodec *_codec = 0);
  ~kpKProcIO();

  bool sstart (RunMode runmode);
};


//////////////////////////////////////////////////////////////////////////////
class  kpPty: public QObject
{ Q_OBJECT
public:
  kpPty();
 ~kpPty();

  QStringList  run(QString cmd, bool inLoop = TRUE,
		   bool needRoot= FALSE);
  bool start(bool needRoot);
  void close();

  QString remote;
  int Result;

private slots:
  void readLines();
  void done();
  void slotTimeout();

public slots:
  void keyOut(char);

signals:
  void textIn(QString, bool);
  void result(QStringList &, int);

private:
  void finish(int ret);

  kpKProcIO* pty;
  QTimer *tm;
  QStringList retList;
  QRegExp terminator;
  bool pUnterm;
  QString uptext;
  bool eventLoop;
  bool started;
  bool timeout;
  bool gotPrompt;
};


#endif
